## net.sourceforge.pmd.stat
Class StatisticalRule

    java.lang.Object
      net.sourceforge.pmd.ast.JavaParserVisitorAdapter
          net.sourceforge.pmd.AbstractRule
              net.sourceforge.pmd.stat.StatisticalRule

All Implemented Interfaces:
  JavaParserVisitor, Rule

Direct Known Subclasses:
  ExcessiveLengthRule, ExcessiveNodeCountRule, SwitchDensityRule

public abstract class StatisticalRule
extends AbstractRule

Author:
  David Dixon-Peugh Aug 8, 2002 StatisticalRule.java

Field Summary
`static double` `DELTA`

Fields inherited from class net.sourceforge.pmd.AbstractRule
`description, example, externalInfoUrl, include, message, name, priority, properties, ruleSetName, usesDFA`

Fields inherited from interface net.sourceforge.pmd.Rule
`LOWEST_PRIORITY, PRIORITIES`

Constructor Summary
`StatisticalRule()`

Method Summary
`void` `addDataPoint(DataPoint point)`
`void` `apply(java.util.List acus, RuleContext ctx)`
`protected java.util.SortedSet` `applyMinimumValue(java.util.SortedSet pointSet, double minValue)`
`protected java.util.SortedSet` `applyTopScore(java.util.SortedSet points, int topScore)`
`protected double` `getMean()`
`protected double` `getStdDev()`
`protected void` `makeViolations(RuleContext ctx, java.util.Set p)`

Methods inherited from class net.sourceforge.pmd.AbstractRule

`addProperties, addProperty, addViolation, addViolation, addViolation, addViolationWithMessage, equals, getBooleanProperty, getDeclaringType, getDescription, getDoubleProperty, getExample, getExternalInfoUrl, getIntProperty, getMessage, getName, getPriority, getPriorityName, getProperties, getRuleSetName, getStringProperty, hashCode, hasProperty, include, setDescription, setExample, setExternalInfoUrl, setInclude, setMessage, setName, setPriority, setRuleSetName, setUsesDFA, usesDFA, visitAll`

Methods inherited from class net.sourceforge.pmd.ast.JavaParserVisitorAdapter

`visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DELTA

    public static double DELTA

Constructor Detail

### StatisticalRule

    public StatisticalRule()

Method Detail

### addDataPoint

    public void addDataPoint(DataPoint point)

### apply

    public void apply(java.util.List acus,
                      RuleContext ctx)

  Specified by:
    `apply` in interface `Rule`
  Overrides:
    `apply` in class `AbstractRule`

### getMean

    protected double getMean()

### getStdDev

    protected double getStdDev()

### applyMinimumValue

    protected java.util.SortedSet applyMinimumValue(java.util.SortedSet pointSet,
                                                    double minValue)

### applyTopScore

    protected java.util.SortedSet applyTopScore(java.util.SortedSet points,
                                                int topScore)

### makeViolations

    protected void makeViolations(RuleContext ctx,
                                  java.util.Set p)

Copyright © 2002-2006 InfoEther. All Rights Reserved.